/*
 * Copyright 2007 Sascha Weinreuter
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.intellij.plugins.relaxNG.model.resolve;

import com.intellij.openapi.project.Project;
import com.intellij.navigation.NavigationItem;
import com.intellij.psi.xml.XmlFile;
import com.intellij.psi.search.PsiElementProcessor;

/**
 * Created by IntelliJ IDEA.
 * User: sweinreuter
 * Date: 26.11.2007
 */
public abstract class RngIndex {
  public static RngIndex getInstance(Project project) {
    return project.getComponent(RngIndex.class);
  }

  public abstract String[] getSymbolNames();

  public abstract NavigationItem[] getSymbolsByName(String name);

  public abstract boolean processForwardDependencies(XmlFile file, PsiElementProcessor<XmlFile> processor);

  public abstract boolean processBackwardDependencies(XmlFile file, PsiElementProcessor<XmlFile> processor);
}
